.include "tn2313def.inc"

.def null          =r5
.def temp0         =r16
.def leds          =r17



.equ FLAGS = GPIOR0
;00000000
;bit 7:
;bit 6:
;bit 5:



;#########################################
.CSEG
.org 0
rjmp RESET
reti; rjmp ; External Interrupt0 Handler
reti; rjmp ; External Interrupt1 Handler
reti; rjmp ; Timer1 Capture Handler
reti; rjmp ; Timer1 CompareA Handler
reti; rjmp ; Timer1 Overflow Handler
reti; rjmp ; Timer0 Overflow Handler
reti; rjmp ; USART0 RX Complete Handler
reti; rjmp ; USART0,UDR Empty Handler
reti; rjmp ; USART0 TX Complete Handler
reti; rjmp ; Analog Comparator Handler
reti; rjmp ; Pin Change Interrupt
reti; rjmp ; Timer1 Compare B Handler
reti; rjmp ; Timer0 Compare A Handler
reti; rjmp ; Timer0 Compare B Handler
reti; rjmp ; USI Start Handler
reti; rjmp ; USI Overflow Handler
reti; rjmp ; EEPROM Ready Handler
reti; rjmp ; Watchdog Overflow Handler

	
RESET:
ldi	temp0,RAMEND ; Locate stack
out	SPL,temp0

ldi temp0,0b11110000 ;Port B7..B4 = out, B3..B0 = in
out DDRB, temp0

ldi temp0,0b00000000
out DDRD, temp0  ; PORTD D7..D0 = in





clr null
ldi leds,0b10000000 ; set initial value





MAIN_LOOP:

rcall PAUSE_1_SEK

out PORTB,leds

rcall ROTATE

rcall PAUSE_1_SEK

out PORTB,null

rjmp MAIN_LOOP


;################################################
ROTATE:
push temp0
mov	temp0,leds	;  
ror	temp0		;   ,  C 
ror	leds		;   0  !
sbrc leds,3 ; skip if bit #2 is clr
ldi leds,0b10000000 ; set initial value
pop temp0
ret

;################################################
PAUSE_1_SEK:
push R17
push R18
push R19
; ============================= 
; ----------------------------- 
; delaying 3999996 cycles:
          ldi  R17, $0B; $24
WGLOOP0:  ldi  R18, $BC
WGLOOP1:  ldi  R19, $C4
WGLOOP2:  dec  R19
          brne WGLOOP2
          dec  R18
          brne WGLOOP1
          dec  R17
          brne WGLOOP0
; ----------------------------- 
; ============================= 
pop R19
pop R18
pop R17
ret

